"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.storage = exports.Storage = exports.PropertyInfo = void 0;
class PropertyInfo {
    constructor(key, options) {
        this.key = '';
        this.key = key;
        this.options = options;
    }
}
exports.PropertyInfo = PropertyInfo;
class Storage {
    constructor() {
        this.map = new Map();
    }
    add(constructor, index, info) {
        if (!this.map.has(constructor)) {
            const newMap = new Map();
            this.map.set(constructor, newMap);
            // inherit
            for (const [c, propertyIndexMap] of this.map.entries()) {
                if (constructor.prototype instanceof c) {
                    for (const [i, p] of propertyIndexMap.entries()) {
                        newMap.set(i, p);
                    }
                }
            }
        }
        const indexMap = this.map.get(constructor).set(index, info);
        this.map.set(constructor, new Map([...indexMap.entries()].sort((a, b) => a[0] - b[0])));
        return this;
    }
    has(constructor) {
        return this.map.has(constructor);
    }
    getPropertyIndexMap(constructor) {
        return this.map.get(constructor);
    }
}
exports.Storage = Storage;
exports.storage = new Storage();
//# sourceMappingURL=storage.js.map