"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-non-null-assertion */
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const src_1 = require("../src");
const PassClassTransformOption_1 = require("./classes/PassClassTransformOption");
const Product_1 = require("./classes/Product");
const factories_1 = require("./factories");
let ArrayTransformAndValidateTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class ArrayTransformAndValidateTest {
    async normal() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        Product_1.productValidate(expected, await src_1.arrayTransformAndValidate(Product_1.Product, this.mapClassToArray(expected)));
    }
    async array() {
        const testData = factories_1.factory.make(Product_1.Product).many(2);
        const results = await src_1.arrayTransformAndValidate(Product_1.Product, testData.map(this.mapClassToArray), { isArray: true });
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(testData.length);
        for (const [i, expected] of testData.entries()) {
            chai_1.expect(results).property(i.toString());
            Product_1.productValidate(expected, results[i]);
        }
    }
    async transformOption() {
        const expected = factories_1.factory.make(PassClassTransformOption_1.PassClassTransformOption).one();
        const result = await src_1.arrayTransformAndValidate(PassClassTransformOption_1.PassClassTransformOption, [expected.id, expected.title], {
            transformer: { strategy: 'excludeAll' },
        });
        chai_1.expect(result).property('constructor', PassClassTransformOption_1.PassClassTransformOption);
        chai_1.expect(result).property('id', 0);
        chai_1.expect(result).property('title', expected.title);
    }
    async fail() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        const input = [
            expected.id.toString(),
            expected.price,
            expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ];
        await chai_1.expect(src_1.arrayTransformAndValidate(Product_1.Product, input)).rejected;
    }
    mapClassToArray(expected) {
        return [
            expected.id,
            expected.price,
            expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ];
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "array", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "transformOption", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidateTest.prototype, "fail", null);
ArrayTransformAndValidateTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], ArrayTransformAndValidateTest);
//# sourceMappingURL=arrayTransformAndValidate.test.js.map