"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.personalBlogValidate = exports.PersonalBlog = exports.Blog = exports.IdBase = void 0;
const chai_1 = require("chai");
const class_fixtures_factory_1 = require("class-fixtures-factory");
const faker_1 = __importDefault(require("faker"));
const src_1 = require("../../src");
const validate_1 = require("../factories/validate");
class IdBase {
    constructor() {
        this.id = 0;
    }
}
__decorate([
    src_1.ArrayMember(0),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number()),
    __metadata("design:type", Object)
], IdBase.prototype, "id", void 0);
exports.IdBase = IdBase;
class Blog extends IdBase {
    constructor() {
        super(...arguments);
        this.title = '';
    }
}
__decorate([
    src_1.ArrayMember(1),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.alphaNumeric()),
    __metadata("design:type", Object)
], Blog.prototype, "title", void 0);
exports.Blog = Blog;
class PersonalBlog extends Blog {
    constructor() {
        super(...arguments);
        this.author = '';
    }
}
__decorate([
    src_1.ArrayMember(2),
    class_fixtures_factory_1.Fixture(() => faker_1.default.name.firstName()),
    __metadata("design:type", Object)
], PersonalBlog.prototype, "author", void 0);
exports.PersonalBlog = PersonalBlog;
function personalBlogValidate(expected, result, options = validate_1.defaultValidateOptions) {
    chai_1.expect(result).not.null;
    if (options.constructor) {
        chai_1.expect(result).property('constructor', PersonalBlog);
    }
    chai_1.expect(result).property('id', expected.id);
    chai_1.expect(result).property('title', expected.title);
    chai_1.expect(result).property('author', expected.author);
}
exports.personalBlogValidate = personalBlogValidate;
//# sourceMappingURL=PersonalBlog.js.map