"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipIndexArrayValidate = exports.skipIndexValidate = exports.SkipIndex = exports.SkipIndexChild = void 0;
require("reflect-metadata");
const chai_1 = require("chai");
const class_fixtures_factory_1 = require("class-fixtures-factory");
const class_transformer_1 = require("class-transformer");
const faker_1 = __importDefault(require("faker"));
const src_1 = require("../../src");
const validate_1 = require("../factories/validate");
class SkipIndexChild {
    constructor() {
        this.id = 1;
        this.name = 'nameChild';
    }
}
__decorate([
    src_1.ArrayMember(0),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number()),
    __metadata("design:type", Object)
], SkipIndexChild.prototype, "id", void 0);
__decorate([
    src_1.ArrayMember(2),
    class_fixtures_factory_1.Fixture(() => faker_1.default.name.firstName()),
    __metadata("design:type", Object)
], SkipIndexChild.prototype, "name", void 0);
exports.SkipIndexChild = SkipIndexChild;
class SkipIndex {
    constructor() {
        this.id = 0;
        this.name = 'name';
        this.childArray = [];
    }
}
__decorate([
    src_1.ArrayMember(0),
    class_fixtures_factory_1.Fixture(() => faker_1.default.random.number()),
    __metadata("design:type", Object)
], SkipIndex.prototype, "id", void 0);
__decorate([
    src_1.ArrayMember(2),
    class_fixtures_factory_1.Fixture(() => faker_1.default.name.firstName()),
    __metadata("design:type", Object)
], SkipIndex.prototype, "name", void 0);
__decorate([
    src_1.ArrayMember(4),
    class_transformer_1.Type(() => SkipIndexChild),
    class_fixtures_factory_1.Fixture({ type: () => SkipIndexChild }),
    __metadata("design:type", SkipIndexChild)
], SkipIndex.prototype, "child", void 0);
__decorate([
    src_1.ArrayMember(6),
    class_transformer_1.Type(() => SkipIndexChild),
    class_fixtures_factory_1.Fixture({ type: () => [SkipIndexChild] }),
    __metadata("design:type", Array)
], SkipIndex.prototype, "childArray", void 0);
exports.SkipIndex = SkipIndex;
function skipIndexValidate(expected, result, options = validate_1.defaultValidateOptions) {
    chai_1.expect(result).not.null;
    if (options.constructor) {
        chai_1.expect(result).property('constructor', SkipIndex);
    }
    chai_1.expect(result).property('id', expected.id);
    chai_1.expect(result).property('name', expected.name);
    if (expected.child) {
        if (options.constructor) {
            chai_1.expect(result).property('child').property('constructor', SkipIndexChild);
        }
        chai_1.expect(result).property('child').property('id', expected.child.id);
        chai_1.expect(result).property('child').property('name', expected.child.name);
    }
    else {
        chai_1.expect((result === null || result === void 0 ? void 0 : result.child) == null).true;
    }
    chai_1.expect(result).property('childArray').property('constructor', Array);
    chai_1.expect(result).property('childArray').length(expected.childArray.length);
    for (const [i, childArray] of expected.childArray.entries()) {
        if (options.constructor) {
            chai_1.expect(result).property('childArray').property(i.toString()).property('constructor', SkipIndexChild);
        }
        chai_1.expect(result).property('childArray').property(i.toString()).property('id', childArray.id);
        chai_1.expect(result).property('childArray').property(i.toString()).property('name', childArray.name);
    }
}
exports.skipIndexValidate = skipIndexValidate;
function skipIndexArrayValidate(expected, result) {
    chai_1.expect(result).not.null;
    chai_1.expect(result).property('constructor', Array);
    chai_1.expect(result).property('0', expected.id);
    chai_1.expect(result).property('2', expected.name);
    if (expected.child) {
        chai_1.expect(result).property('4').property('constructor', Array);
        chai_1.expect(result).property('4').property('0', expected.child.id);
        chai_1.expect(result).property('4').property('2', expected.child.name);
    }
    else {
        chai_1.expect((result === null || result === void 0 ? void 0 : result[4]) == null).true;
    }
    chai_1.expect(result).property('6').property('constructor', Array);
    chai_1.expect(result).property('6').length(expected.childArray.length);
    for (const [i, childArray] of expected.childArray.entries()) {
        chai_1.expect(result).property('6').property(i.toString()).property('0', childArray.id);
        chai_1.expect(result).property('6').property(i.toString()).property('2', childArray.name);
    }
}
exports.skipIndexArrayValidate = skipIndexArrayValidate;
//# sourceMappingURL=SkipIndex.js.map