"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const src_1 = require("../src");
const Override_1 = require("./classes/Override");
const PassClassTransformOption_1 = require("./classes/PassClassTransformOption");
const PersonalBlog_1 = require("./classes/PersonalBlog");
const Product_1 = require("./classes/Product");
const factories_1 = require("./factories");
/* eslint-disable @typescript-eslint/no-non-null-assertion */
let PlainArrayToClassTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class PlainArrayToClassTest {
    normal() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        Product_1.productValidate(expected, src_1.plainArrayToClass(Product_1.Product, [
            expected.id,
            expected.price,
            +expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ]));
    }
    array() {
        const testData = factories_1.factory.make(Product_1.Product).many(2);
        const results = src_1.plainArrayToClass(Product_1.Product, testData.map((expected) => [
            expected.id,
            expected.price,
            +expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ]), { isArray: true });
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(testData.length);
        for (const [i, expected] of testData.entries()) {
            chai_1.expect(results).property(i.toString());
            Product_1.productValidate(expected, results[i]);
        }
    }
    classTransformOption() {
        const expected = factories_1.factory.make(PassClassTransformOption_1.PassClassTransformOption).one();
        const result = src_1.plainArrayToClass(PassClassTransformOption_1.PassClassTransformOption, [expected.id, expected.title], { strategy: 'excludeAll' });
        chai_1.expect(result).property('constructor', PassClassTransformOption_1.PassClassTransformOption);
        chai_1.expect(result).property('id', 0);
        chai_1.expect(result).property('title', expected.title);
    }
    extendsClass() {
        const expected = factories_1.factory.make(PersonalBlog_1.PersonalBlog).one();
        PersonalBlog_1.personalBlogValidate(expected, src_1.plainArrayToClass(PersonalBlog_1.PersonalBlog, [expected.id, expected.title, expected.author]));
    }
    overrideClass() {
        const expected = factories_1.factory.make(Override_1.Override).one();
        Override_1.OverrideValidate(Object.assign(new Override_1.Override(), {
            weight: expected.weight,
        }), src_1.plainArrayToClass(Override_1.Override, [expected.weight]));
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainArrayToClassTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainArrayToClassTest.prototype, "array", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainArrayToClassTest.prototype, "classTransformOption", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainArrayToClassTest.prototype, "extendsClass", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainArrayToClassTest.prototype, "overrideClass", null);
PlainArrayToClassTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], PlainArrayToClassTest);
//# sourceMappingURL=plainArrayToClass.test.js.map