"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-sparse-arrays */
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const class_transformer_1 = require("class-transformer");
const src_1 = require("../src");
const Product_1 = require("./classes/Product");
const SkipIndex_1 = require("./classes/SkipIndex");
const factories_1 = require("./factories");
/* eslint-disable @typescript-eslint/no-non-null-assertion */
class UnknownClass {
}
class ObjectMapChild {
    constructor() {
        this.id = 0;
    }
}
__decorate([
    src_1.ArrayMember(0),
    __metadata("design:type", Object)
], ObjectMapChild.prototype, "id", void 0);
class ObjectMap {
}
__decorate([
    src_1.ArrayMember(0),
    class_transformer_1.Type(() => ObjectMapChild),
    __metadata("design:type", ObjectMapChild)
], ObjectMap.prototype, "test", void 0);
let PlainMapValueTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class PlainMapValueTest {
    normal() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        const result = src_1.plainMapValue(Product_1.Product, [
            expected.id,
            expected.price,
            expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ]);
        chai_1.expect(result).property('constructor', Object);
        Product_1.productValidate(expected, result, { constructor: false });
    }
    object() {
        const obj = { ok: 1 };
        const result = src_1.plainMapValue(ObjectMap, [obj]);
        chai_1.expect(result).property('constructor', Object);
        chai_1.expect(result).property('test', obj);
    }
    skipIndex() {
        const expected = factories_1.factory.make(SkipIndex_1.SkipIndex).one();
        const arr = [
            expected.id,
            ,
            expected.name,
            ,
            [
                expected.child.id,
                ,
                expected.child.name,
            ],
            ,
            expected.childArray.map((p) => [
                p.id,
                ,
                p.name,
            ]),
        ];
        const result = src_1.plainMapValue(SkipIndex_1.SkipIndex, arr);
        chai_1.expect(result).property('constructor', Object);
        SkipIndex_1.skipIndexValidate(expected, result, { constructor: false });
    }
    unknownClass() {
        chai_1.expect(() => src_1.plainMapValue(UnknownClass, [])).throw(src_1.UnknownClassError);
    }
    inputIsNotArray() {
        chai_1.expect(() => src_1.plainMapValue(Product_1.Product, null)).throw(TypeError);
        chai_1.expect(() => src_1.plainMapValue(Product_1.Product, 1)).throw(TypeError);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainMapValueTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainMapValueTest.prototype, "object", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainMapValueTest.prototype, "skipIndex", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainMapValueTest.prototype, "unknownClass", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PlainMapValueTest.prototype, "inputIsNotArray", null);
PlainMapValueTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], PlainMapValueTest);
//# sourceMappingURL=plainMapValue.test.js.map